// This file was generated by gir (https://github.com/gtk-rs/gir)
// from gir-files (https://github.com/gtk-rs/gir-files)
// DO NOT EDIT

use app_stream_glib_sys;
use glib::translate::*;

bitflags! {
    pub struct AppParseFlags: u32 {
        const NONE = 0;
        const USE_HEURISTICS = 1;
        const KEEP_COMMENTS = 2;
        const CONVERT_TRANSLATABLE = 4;
        const APPEND_DATA = 8;
        const ALLOW_VETO = 16;
        const USE_FALLBACKS = 32;
        const ADD_ALL_METADATA = 64;
        const ONLY_NATIVE_LANGS = 128;
    }
}

#[doc(hidden)]
impl ToGlib for AppParseFlags {
    type GlibType = app_stream_glib_sys::AsAppParseFlags;

    fn to_glib(&self) -> app_stream_glib_sys::AsAppParseFlags {
        self.bits()
    }
}

#[doc(hidden)]
impl FromGlib<app_stream_glib_sys::AsAppParseFlags> for AppParseFlags {
    fn from_glib(value: app_stream_glib_sys::AsAppParseFlags) -> AppParseFlags {
        AppParseFlags::from_bits_truncate(value)
    }
}

bitflags! {
    pub struct AppQuirk: u32 {
        const NONE = 0;
        const PROVENANCE = 1;
        const COMPULSORY = 2;
        const HAS_SOURCE = 4;
        const MATCH_ANY_PREFIX = 8;
        const NEEDS_REBOOT = 16;
        const NOT_REVIEWABLE = 32;
        const HAS_SHORTCUT = 64;
        const NOT_LAUNCHABLE = 128;
        const NEEDS_USER_ACTION = 256;
        const IS_PROXY = 512;
        const REMOVABLE_HARDWARE = 1024;
        const DEVELOPER_VERIFIED = 2048;
    }
}

#[doc(hidden)]
impl ToGlib for AppQuirk {
    type GlibType = app_stream_glib_sys::AsAppQuirk;

    fn to_glib(&self) -> app_stream_glib_sys::AsAppQuirk {
        self.bits()
    }
}

#[doc(hidden)]
impl FromGlib<app_stream_glib_sys::AsAppQuirk> for AppQuirk {
    fn from_glib(value: app_stream_glib_sys::AsAppQuirk) -> AppQuirk {
        AppQuirk::from_bits_truncate(value)
    }
}

bitflags! {
    pub struct AppSearchMatch: u32 {
        const NONE = 0;
        const MIMETYPE = 1;
        const PKGNAME = 2;
        const DESCRIPTION = 4;
        const COMMENT = 8;
        const NAME = 16;
        const KEYWORD = 32;
        const ID = 64;
        const ORIGIN = 128;
    }
}

#[doc(hidden)]
impl ToGlib for AppSearchMatch {
    type GlibType = app_stream_glib_sys::AsAppSearchMatch;

    fn to_glib(&self) -> app_stream_glib_sys::AsAppSearchMatch {
        self.bits()
    }
}

#[doc(hidden)]
impl FromGlib<app_stream_glib_sys::AsAppSearchMatch> for AppSearchMatch {
    fn from_glib(value: app_stream_glib_sys::AsAppSearchMatch) -> AppSearchMatch {
        AppSearchMatch::from_bits_truncate(value)
    }
}

bitflags! {
    pub struct AppSubsumeFlags: u32 {
        const NONE = 0;
        const NO_OVERWRITE = 1;
        const BOTH_WAYS = 2;
        const REPLACE = 4;
        const KIND = 8;
        const STATE = 16;
        const BUNDLES = 32;
        const TRANSLATIONS = 64;
        const RELEASES = 128;
        const KUDOS = 256;
        const CATEGORIES = 512;
        const PERMISSIONS = 1024;
        const EXTENDS = 2048;
        const COMPULSORY = 4096;
        const SCREENSHOTS = 8192;
        const REVIEWS = 16384;
        const CONTENT_RATINGS = 32768;
        const PROVIDES = 65536;
        const ICONS = 131072;
        const MIMETYPES = 262144;
        const VETOS = 524288;
        const LANGUAGES = 1048576;
        const NAME = 2097152;
        const COMMENT = 4194304;
        const DEVELOPER_NAME = 8388608;
        const DESCRIPTION = 16777216;
        const METADATA = 33554432;
        const URL = 67108864;
        const KEYWORDS = 134217728;
        const FORMATS = 268435456;
        const BRANCH = 536870912;
        const ORIGIN = 1073741824;
        const METADATA_LICENSE = 2147483648;
        const PROJECT_LICENSE = 0;
        const PROJECT_GROUP = 0;
        const SOURCE_KIND = 0;
        const SUGGESTS = 0;
        const LAUNCHABLES = 0;
        const AGREEMENTS = 0;
    }
}

#[doc(hidden)]
impl ToGlib for AppSubsumeFlags {
    type GlibType = app_stream_glib_sys::AsAppSubsumeFlags;

    fn to_glib(&self) -> app_stream_glib_sys::AsAppSubsumeFlags {
        self.bits()
    }
}

#[doc(hidden)]
impl FromGlib<app_stream_glib_sys::AsAppSubsumeFlags> for AppSubsumeFlags {
    fn from_glib(value: app_stream_glib_sys::AsAppSubsumeFlags) -> AppSubsumeFlags {
        AppSubsumeFlags::from_bits_truncate(value)
    }
}

bitflags! {
    pub struct InfLoadFlags: u32 {
        const NONE = 0;
        const STRICT = 1;
        const CASE_INSENSITIVE = 2;
    }
}

#[doc(hidden)]
impl ToGlib for InfLoadFlags {
    type GlibType = app_stream_glib_sys::AsInfLoadFlags;

    fn to_glib(&self) -> app_stream_glib_sys::AsInfLoadFlags {
        self.bits()
    }
}

#[doc(hidden)]
impl FromGlib<app_stream_glib_sys::AsInfLoadFlags> for InfLoadFlags {
    fn from_glib(value: app_stream_glib_sys::AsInfLoadFlags) -> InfLoadFlags {
        InfLoadFlags::from_bits_truncate(value)
    }
}

bitflags! {
    pub struct MarkupConvertFlag: u32 {
        const NONE = 0;
        const IGNORE_ERRORS = 1;
    }
}

#[doc(hidden)]
impl ToGlib for MarkupConvertFlag {
    type GlibType = app_stream_glib_sys::AsMarkupConvertFlag;

    fn to_glib(&self) -> app_stream_glib_sys::AsMarkupConvertFlag {
        self.bits()
    }
}

#[doc(hidden)]
impl FromGlib<app_stream_glib_sys::AsMarkupConvertFlag> for MarkupConvertFlag {
    fn from_glib(value: app_stream_glib_sys::AsMarkupConvertFlag) -> MarkupConvertFlag {
        MarkupConvertFlag::from_bits_truncate(value)
    }
}

bitflags! {
    pub struct NodeFromXmlFlags: u32 {
        const NONE = 0;
        const LITERAL_TEXT = 1;
        const KEEP_COMMENTS = 2;
        const ONLY_NATIVE_LANGS = 4;
    }
}

#[doc(hidden)]
impl ToGlib for NodeFromXmlFlags {
    type GlibType = app_stream_glib_sys::AsNodeFromXmlFlags;

    fn to_glib(&self) -> app_stream_glib_sys::AsNodeFromXmlFlags {
        self.bits()
    }
}

#[doc(hidden)]
impl FromGlib<app_stream_glib_sys::AsNodeFromXmlFlags> for NodeFromXmlFlags {
    fn from_glib(value: app_stream_glib_sys::AsNodeFromXmlFlags) -> NodeFromXmlFlags {
        NodeFromXmlFlags::from_bits_truncate(value)
    }
}

#[cfg(any(feature = "v0_6_1", feature = "dox"))]
bitflags! {
    pub struct ReviewFlags: u32 {
        const NONE = 0;
        const SELF = 1;
        const VOTED = 2;
    }
}

#[cfg(any(feature = "v0_6_1", feature = "dox"))]
#[doc(hidden)]
impl ToGlib for ReviewFlags {
    type GlibType = app_stream_glib_sys::AsReviewFlags;

    fn to_glib(&self) -> app_stream_glib_sys::AsReviewFlags {
        self.bits()
    }
}

#[cfg(any(feature = "v0_6_1", feature = "dox"))]
#[doc(hidden)]
impl FromGlib<app_stream_glib_sys::AsReviewFlags> for ReviewFlags {
    fn from_glib(value: app_stream_glib_sys::AsReviewFlags) -> ReviewFlags {
        ReviewFlags::from_bits_truncate(value)
    }
}

bitflags! {
    pub struct StoreAddFlags: u32 {
        const NONE = 0;
        const PREFER_LOCAL = 1;
        const USE_UNIQUE_ID = 2;
        const USE_MERGE_HEURISTIC = 4;
        const ONLY_NATIVE_LANGS = 8;
    }
}

#[doc(hidden)]
impl ToGlib for StoreAddFlags {
    type GlibType = app_stream_glib_sys::AsStoreAddFlags;

    fn to_glib(&self) -> app_stream_glib_sys::AsStoreAddFlags {
        self.bits()
    }
}

#[doc(hidden)]
impl FromGlib<app_stream_glib_sys::AsStoreAddFlags> for StoreAddFlags {
    fn from_glib(value: app_stream_glib_sys::AsStoreAddFlags) -> StoreAddFlags {
        StoreAddFlags::from_bits_truncate(value)
    }
}

bitflags! {
    pub struct StoreLoadFlags: u32 {
        const NONE = 0;
        const APP_INFO_SYSTEM = 1;
        const APP_INFO_USER = 2;
        const APP_INSTALL = 4;
        const APPDATA = 8;
        const DESKTOP = 16;
        const ALLOW_VETO = 32;
        const FLATPAK_USER = 64;
        const FLATPAK_SYSTEM = 128;
        const IGNORE_INVALID = 256;
        const ONLY_UNCOMPRESSED = 512;
        const ONLY_MERGE_APPS = 1024;
    }
}

#[doc(hidden)]
impl ToGlib for StoreLoadFlags {
    type GlibType = app_stream_glib_sys::AsStoreLoadFlags;

    fn to_glib(&self) -> app_stream_glib_sys::AsStoreLoadFlags {
        self.bits()
    }
}

#[doc(hidden)]
impl FromGlib<app_stream_glib_sys::AsStoreLoadFlags> for StoreLoadFlags {
    fn from_glib(value: app_stream_glib_sys::AsStoreLoadFlags) -> StoreLoadFlags {
        StoreLoadFlags::from_bits_truncate(value)
    }
}

bitflags! {
    pub struct UniqueIdMatchFlags: u32 {
        const NONE = 0;
        const SCOPE = 1;
        const BUNDLE_KIND = 2;
        const ORIGIN = 4;
        const KIND = 8;
        const ID = 16;
        const BRANCH = 32;
    }
}

#[doc(hidden)]
impl ToGlib for UniqueIdMatchFlags {
    type GlibType = app_stream_glib_sys::AsUniqueIdMatchFlags;

    fn to_glib(&self) -> app_stream_glib_sys::AsUniqueIdMatchFlags {
        self.bits()
    }
}

#[doc(hidden)]
impl FromGlib<app_stream_glib_sys::AsUniqueIdMatchFlags> for UniqueIdMatchFlags {
    fn from_glib(value: app_stream_glib_sys::AsUniqueIdMatchFlags) -> UniqueIdMatchFlags {
        UniqueIdMatchFlags::from_bits_truncate(value)
    }
}

bitflags! {
    pub struct UtilsFindIconFlag: u32 {
        const NONE = 0;
        const HI_DPI = 1;
    }
}

#[doc(hidden)]
impl ToGlib for UtilsFindIconFlag {
    type GlibType = app_stream_glib_sys::AsUtilsFindIconFlag;

    fn to_glib(&self) -> app_stream_glib_sys::AsUtilsFindIconFlag {
        self.bits()
    }
}

#[doc(hidden)]
impl FromGlib<app_stream_glib_sys::AsUtilsFindIconFlag> for UtilsFindIconFlag {
    fn from_glib(value: app_stream_glib_sys::AsUtilsFindIconFlag) -> UtilsFindIconFlag {
        UtilsFindIconFlag::from_bits_truncate(value)
    }
}

bitflags! {
    pub struct VersionCompareFlag: u32 {
        const NONE = 0;
        const USE_HEURISTICS = 1;
    }
}

#[doc(hidden)]
impl ToGlib for VersionCompareFlag {
    type GlibType = app_stream_glib_sys::AsVersionCompareFlag;

    fn to_glib(&self) -> app_stream_glib_sys::AsVersionCompareFlag {
        self.bits()
    }
}

#[doc(hidden)]
impl FromGlib<app_stream_glib_sys::AsVersionCompareFlag> for VersionCompareFlag {
    fn from_glib(value: app_stream_glib_sys::AsVersionCompareFlag) -> VersionCompareFlag {
        VersionCompareFlag::from_bits_truncate(value)
    }
}

bitflags! {
    pub struct VersionParseFlag: u32 {
        const NONE = 0;
        const USE_TRIPLET = 1;
        const USE_BCD = 2;
    }
}

#[doc(hidden)]
impl ToGlib for VersionParseFlag {
    type GlibType = app_stream_glib_sys::AsVersionParseFlag;

    fn to_glib(&self) -> app_stream_glib_sys::AsVersionParseFlag {
        self.bits()
    }
}

#[doc(hidden)]
impl FromGlib<app_stream_glib_sys::AsVersionParseFlag> for VersionParseFlag {
    fn from_glib(value: app_stream_glib_sys::AsVersionParseFlag) -> VersionParseFlag {
        VersionParseFlag::from_bits_truncate(value)
    }
}

